#version 400
layout(location = 0) in vec3 vp;
layout(location =1) in vec2 vertexUV;
layout(location = 2) in vec3 vn;

out vec2 UV;
out vec3 Position_worldspace;
out vec3 Normal_cameraspace;
out vec3 EyeDirection_cameraspace;
out vec3 LightDirection_cameraspace;

uniform mat4 MVP;
//uniform mat4 V;
uniform mat4 MV;
uniform vec3 LightPosition_worldspace;

void main () {
	gl_Position = MVP*vec4 (vp, 1.0);
	UV=vertexUV;
	
//light calculation	
	Position_worldspace = vp;//(M * vec4(vertexPosition_modelspace,1)).xyz;
	vec3 vertexPosition_cameraspace = ( MV* vec4(vp,1)).xyz;
	EyeDirection_cameraspace = vec3(0,0,0) - vertexPosition_cameraspace;	
	vec3 LightPosition_cameraspace = ( MV * vec4(LightPosition_worldspace,1)).xyz;
	LightDirection_cameraspace = LightPosition_cameraspace + EyeDirection_cameraspace;
	Normal_cameraspace = ( MV * vec4(vn,0)).xyz;
};