#version 400
uniform sampler2D myTextureSampler;
uniform sampler2D normalMapSampler;
uniform sampler2D gDisplacementMap;
uniform vec3 LightPosition_worldspace;

in vec2 UV;
in vec3 Position_worldspace;
//in vec3 Normal_cameraspace;
in vec3 EyeDirection_cameraspace;
in vec3 LightDirection_cameraspace;

in vec3 EyeDirection_tangentspace;
in vec3 LightDirection_tangentspace;

out vec3 color;

vec2 TraceRay(in float height, in vec2 coords, in vec3 dir, in float mipmap){

    vec2 NewCoords = coords;
    vec2 dUV = - dir.xy * height * 0.08;
    float SearchHeight = 1.0;
    float prev_hits = 0.0;
    float hit_h = 0.0;

    for(int i=0;i<10;i++){
        SearchHeight -= 0.1;
        NewCoords += dUV;
        float CurrentHeight = texture2D(gDisplacementMap,NewCoords.xy).r;
        float first_hit = clamp((CurrentHeight - SearchHeight - prev_hits) * 499999.0,0.0,1.0);
        hit_h += first_hit * SearchHeight;
        prev_hits += first_hit;
    }
    NewCoords = coords + dUV * (1.0-hit_h) * 10.0f - dUV;

    vec2 Temp = NewCoords;
    SearchHeight = hit_h+0.1;
    float Start = SearchHeight;
    dUV *= 0.2;
    prev_hits = 0.0;
    hit_h = 0.0;
    for(int i=0;i<5;i++){
        SearchHeight -= 0.02;
        NewCoords += dUV;
        float CurrentHeight = texture2D(gDisplacementMap,NewCoords.xy).r;
        float first_hit = clamp((CurrentHeight - SearchHeight - prev_hits) * 499999.0,0.0,1.0);
        hit_h += first_hit * SearchHeight;
        prev_hits += first_hit;    
    }
    NewCoords = Temp + dUV * (Start - hit_h)*50.0f;

    return NewCoords;
}

void main( void )
{
	vec3 LightColor = vec3(1,1,1);
	float LightPower = 5.0f;
	
   vec3  fvLightDirection = normalize( LightDirection_tangentspace );
   vec3  fvViewDirection  = normalize( EyeDirection_tangentspace );

      vec3  fvViewDirection2  = normalize( EyeDirection_cameraspace);

	  float fac=1;
   vec2 uv;
   uv.x=abs(UV.x);
   uv.y=abs(UV.y);
   float mipmap = 0;
   vec3 h=fvViewDirection;
  /* if (uv.x>0.5 ){
   h=fvViewDirection2;
   fac=2;
   }*/
   vec2 NewCoord = TraceRay(0.1,UV,fvViewDirection,mipmap);

   //vec2 ddx = dFdx(NewCoord);
   //vec2 ddy = dFdy(NewCoord);
   
   	// Distance to the light
	float distance = length( LightPosition_worldspace - Position_worldspace );

   vec3 BumpMapNormal = texture2D(normalMapSampler, NewCoord.xy).xyz;
   BumpMapNormal = normalize(2.0 * BumpMapNormal - vec3(1.0, 1.0, 1.0));

   vec3  fvNormal         = BumpMapNormal;
   float fNDotL           = dot( fvNormal, fvLightDirection ); //cosTheta

  /* vec3  fvReflection     = normalize( ( ( 2.0 * fvNormal ) * fNDotL ) - fvLightDirection ); 
   float fRDotV           = max( 0.0, dot( fvReflection, fvViewDirection ) );*/ //cosalpha
	vec3 E = normalize(EyeDirection_tangentspace);
	// Direction in which the triangle reflects the light
	vec3 R = reflect(-fvLightDirection,fvNormal);
	// Cosine of the angle between the Eye vector and the Reflect vector,
	// clamped to 0
	//  - Looking into the reflection -> 1
	//  - Looking elsewhere -> < 1
	float cosAlpha = clamp( dot( E,R ), 0,1 );
   
   	vec3 MaterialDiffuseColor =color=texture2D( myTextureSampler, NewCoord.xy).rgb;
	vec3 MaterialAmbientColor = vec3(0.1,0.1,0.1) * MaterialDiffuseColor;
	vec3 MaterialSpecularColor = vec3(0.3,0.3,0.3);


   color =//fvViewDirection;
   //vec3(NewCoord.x,-NewCoord.y,0); /* //vec3(1,0,0);
		MaterialAmbientColor +
		// Diffuse : "color" of the object
		MaterialDiffuseColor * LightColor * LightPower * fNDotL / (distance*distance) +
		// Specular : reflective highlight, like a mirror
		MaterialSpecularColor * LightColor * LightPower * pow(cosAlpha,2) / (distance*distance);

}