#version 400
in vec2 UV;
in vec3 Position_worldspace;
in vec3 Normal_cameraspace;
in vec3 EyeDirection_cameraspace;
in vec3 LightDirection_cameraspace;

/*vec3 colors[5]={{1,0,0},
				{0,1,0},
				{0,0,1},
				{1,1,0},
				{0,1,1}}*/
out vec3 frag_colour;
uniform sampler2D myTextureSampler;
uniform vec3 LightPosition_worldspace;
uniform sampler2D gDisplacementMap;

uniform float lightsOn;

void main () {
	vec3 LightColor = vec3(1,1,1);
	float LightPower = 10.0f;
	
	// Material properties
	vec3 MaterialDiffuseColor =texture2D( myTextureSampler, UV ).rgb;
	vec3 MaterialAmbientColor = lightsOn*vec3(0.1,0.1,0.1) * MaterialDiffuseColor+  abs(lightsOn-1.0f)*MaterialDiffuseColor;
	vec3 MaterialSpecularColor = vec3(0.3,0.3,0.3);

	// Distance to the light
	float distance = length( LightPosition_worldspace - Position_worldspace );

	// Normal of the computed fragment, in camera space
	vec3 n = normalize( Normal_cameraspace );
	vec3 l = normalize( LightDirection_cameraspace );
	float cosTheta = clamp( dot( n,l ), 0,1 );
	
	vec3 E = normalize(EyeDirection_cameraspace);
	vec3 R = reflect(-l,n);
	float cosAlpha = clamp( dot( E,R ), 0,1 );
	
	frag_colour = //vec3(UV,0);
	//Normal_cameraspace;
	
	//;
	//vec3(UV,1);//Position_worldspace;
//LightPosition_worldspace;
		// Ambient : simulates indirect lighting
		MaterialAmbientColor +
		// Diffuse : "color" of the object
		lightsOn*MaterialDiffuseColor * LightColor * LightPower * cosTheta / (distance*distance) +
		// Specular : reflective highlight, like a mirror
		lightsOn*MaterialSpecularColor * LightColor * LightPower * pow(cosAlpha,2) / (distance*distance);
};